AnyType (Hibernate JavaDocs)
Date: 2012-04-05

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hibernate.type
Class AnyType

    java.lang.Object
      org.hibernate.type.AbstractType
          org.hibernate.type.AnyType

All Implemented Interfaces:
  Serializable, AssociationType, CompositeType, Type

Direct Known Subclasses:
  ObjectType

    public class AnyType

extends AbstractType
implements CompositeType, AssociationType

Handles "any" mappings

See Also:
  Serialized Form

Nested Class Summary
`static class` | `AnyType.ObjectTypeCacheEntry`

Field Summary

Fields inherited from class org.hibernate.type.AbstractType
`LEGACY_DEFAULT_SIZE, LEGACY_DICTATED_SIZE`

Constructor Summary
`AnyType(Type metaType, Type identifierType)`

Method Summary
`Object` | `assemble(Serializable cached, SessionImplementor session, Object owner)` Reconstruct the object from its disassembled state.
`int` | `compare(Object x, Object y)` Perform a `Comparator` style comparison between values
`Object` | `deepCopy(Object value, SessionFactoryImplementor factory)` Return a deep copy of the persistent state, stopping at entities and at collections.
`Size[]` | `defaultSizes(Mapping mapping)` Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).
`Size[]` | `dictatedSizes(Mapping mapping)` Return the column sizes dictated by this type.
`Serializable` | `disassemble(Object value, SessionImplementor session, Object owner)` Return a disassembled representation of the object.
`Object` | `fromXMLNode(org.dom4j.Node xml, Mapping factory)` Parse the XML representation of an instance.
`String` | `getAssociatedEntityName(SessionFactoryImplementor factory)` Get the entity name of the associated entity
`Joinable` | `getAssociatedJoinable(SessionFactoryImplementor factory)` Get the "persister" for this association - a class or collection persister
`CascadeStyle` | `getCascadeStyle(int i)` Retrieve the cascade style of the indicated component property.
`int` | `getColumnSpan(Mapping session)` How many columns are used to persist this type.
`FetchMode` | `getFetchMode(int i)` Retrieve the fetch mode of the indicated component property.
`ForeignKeyDirection` | `getForeignKeyDirection()` Get the foreign key directionality of this association
`String` | `getLHSPropertyName()` Get the name of a property in the owning entity that provides the join key (null if the identifier)
`String` | `getName()` Returns the abbreviated name of the type.
`String` | `getOnCondition(String alias, SessionFactoryImplementor factory, Map enabledFilters)` Get the "filtering" SQL fragment that is applied in the SQL on clause, in addition to the usual join condition
`String[]` | `getPropertyNames()` Get the names of the component properties
`boolean[]` | `getPropertyNullability()` Retrieve the indicators regarding which component properties are nullable.
`Object` | `getPropertyValue(Object component, int i, SessionImplementor session)` Extract a particular component property value indicated by index.
`Object[]` | `getPropertyValues(Object component, EntityMode entityMode)` Extract the values of the component properties from the given component instance without access to the session.
`Object[]` | `getPropertyValues(Object component, SessionImplementor session)` Extract the values of the component properties from the given component instance
`Class` | `getReturnedClass()` The class returned by `Type.nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods.
`String` | `getRHSUniqueKeyPropertyName()` The name of a unique property of the associated entity that provides the join key (null if the identifier of an entity, or key of a collection)
`Type[]` | `getSubtypes()` Get the types of the component properties
`Object` | `hydrate(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Extract a value from the JDBC result set.
`boolean` | `isAlwaysDirtyChecked()` Do we dirty check this association, even when there are no columns to be updated?
`boolean` | `isAnyType()` Return true if the implementation is castable to `AnyType`.
`boolean` | `isAssociationType()` Return true if the implementation is castable to `AssociationType`.
`boolean` | `isComponentType()` Return true if the implementation is castable to `CompositeType`.
`boolean` | `isDirty(Object old, Object current, boolean[] checkable, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` | `isEmbedded()` Is this component embedded? "embedded" indicates that the component is "virtual", that its properties are "flattened" onto its owner
`boolean` | `isEmbeddedInXML()`
`boolean` | `isMethodOf(Method method)` Is the given method a member of this component's class?
`boolean` | `isModified(Object old, Object current, boolean[] checkable, SessionImplementor session)` Has the value been modified compared to the current database state? The difference between this and the `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values.
`boolean` | `isMutable()` Are objects of this type mutable.
`boolean` | `isReferenceToPrimaryKey()`
`boolean` | `isSame(Object x, Object y)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.
`Object` | `nullSafeGet(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`Object` | `nullSafeGet(ResultSet rs, String name, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`void` | `nullSafeSet(PreparedStatement st, Object value, int index, boolean[] settable, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter.
`void` | `nullSafeSet(PreparedStatement st, Object value, int index, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement.
`Object` | `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` | `resolve(Object value, SessionImplementor session, Object owner)` The second phase of 2-phase loading.
`Object` | `semiResolve(Object value, SessionImplementor session, Object owner)` Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.
`void` | `setPropertyValues(Object component, Object[] values, EntityMode entityMode)` Inject property values onto the given component instance An optional operation
`void` | `setToXMLNode(org.dom4j.Node xml, Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in an XML element.
`int[]` | `sqlTypes(Mapping mapping)` Return the JDBC types codes (per `Types`) for the columns mapped by this type.
`boolean[]` | `toColumnNullness(Object value, Mapping mapping)` Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.
`String` | `toLoggableString(Object value, SessionFactoryImplementor factory)` Generate a representation of the value for logging purposes.
`boolean` | `useLHSPrimaryKey()` Is the primary key of the owning entity table to be used in the join?

Methods inherited from class org.hibernate.type.AbstractType
`beforeAssemble, getHashCode, getHashCode, getSemiResolvedType, isCollectionType, isDirty, isEntityType, isEqual, isEqual, isXMLElement, replace, replaceNode`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.hibernate.type.Type
`beforeAssemble, getHashCode, getHashCode, getSemiResolvedType, isCollectionType, isDirty, isEntityType, isEqual, isEqual, isXMLElement, replace`

Constructor Detail

### AnyType

    public AnyType(Type metaType,
                   Type identifierType)

Method Detail

### deepCopy

    public Object deepCopy(Object value,
                           SessionFactoryImplementor factory)
                    throws HibernateException

  Description copied from interface: `Type`
  Return a deep copy of the persistent state, stopping at entities and at collections.

  Specified by:
    `deepCopy` in interface `Type`
  Parameters:
    `value` - The value to be copied
    `factory` - The session factory
  Returns:
    The deep copy
  Throws:
    `HibernateException` - An error from Hibernate

### isMethodOf

    public boolean isMethodOf(Method method)

  Description copied from interface: `CompositeType`
  Is the given method a member of this component's class?

  Specified by:
    `isMethodOf` in interface `CompositeType`
  Parameters:
    `method` - The method to check
  Returns:
    True if the method is a member; false otherwise.

### isSame

    public boolean isSame(Object x,
                          Object y)
                   throws HibernateException

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.

  For most types this should equate to an `equals` check on the values. For associations the implication is a bit different. For most types it is conceivable to simply delegate to `Type.isEqual(java.lang.Object, java.lang.Object)`

  Specified by:
    `isSame` in interface `Type`
  Overrides:
    `isSame` in class `AbstractType`
  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    True if there are considered the same (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### compare

    public int compare(Object x,
                       Object y)

  Description copied from interface: `Type`
  Perform a `Comparator` style comparison between values

  Specified by:
    `compare` in interface `Type`
  Overrides:
    `compare` in class `AbstractType`
  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    The comparison result. See `Comparator.compare(T, T)` for a discussion.

### getColumnSpan

    public int getColumnSpan(Mapping session)
                      throws MappingException

  Description copied from interface: `Type`
  How many columns are used to persist this type. Always the same as `sqlTypes(mapping).length`

  Specified by:
    `getColumnSpan` in interface `Type`
  Parameters:
    `session` - The mapping object :/
  Returns:
    The number of columns
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### getName

    public String getName()

  Description copied from interface: `Type`
  Returns the abbreviated name of the type.

  Specified by:
    `getName` in interface `Type`
  Returns:
    String the Hibernate type name

### isMutable

    public boolean isMutable()

  Description copied from interface: `Type`
  Are objects of this type mutable. (With respect to the referencing object ... entities and collections are considered immutable because they manage their own internal state.)

  Specified by:
    `isMutable` in interface `Type`
  Returns:
    boolean

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String name,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException,
                              SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values. This form might be called if the type is known to be a single-column type.

  Specified by:
    `nullSafeGet` in interface `Type`
  Parameters:
    `rs` - The result set from which to extract value.
    `name` - the column name making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String[] names,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException,
                              SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values.

  Specified by:
    `nullSafeGet` in interface `Type`
  Parameters:
    `rs` - The result set from which to extract value.
    `names` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver
  See Also:
    `alternative, 2-phase property initialization`

### hydrate

    public Object hydrate(ResultSet rs,
                          String[] names,
                          SessionImplementor session,
                          Object owner)
                   throws HibernateException,
                          SQLException

  Description copied from interface: `Type`
  Extract a value from the JDBC result set. This is useful for 2-phase property initialization - the second phase is a call to `Type.resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` This hydrated value will be either:
  - in the case of an entity or collection type, the key
  - otherwise, the value itself

  Specified by:
    `hydrate` in interface `Type`
  Overrides:
    `hydrate` in class `AbstractType`
  Parameters:
    `rs` - The JDBC result set
    `names` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    An entity or collection key, or an actual value.
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver
  See Also:
    `Type.resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### resolve

    public Object resolve(Object value,
                          SessionImplementor session,
                          Object owner)
                   throws HibernateException

  Description copied from interface: `Type`
  The second phase of 2-phase loading. Only really pertinent for entities and collections. Here we resolve the identifier to an entity or collection instance

  Specified by:
    `resolve` in interface `Type`
  Overrides:
    `resolve` in class `AbstractType`
  Parameters:
    `value` - an identifier or value returned by `hydrate()`
    `session` - the session
    `owner` - the parent entity
  Returns:
    the given value, or the value associated with the identifier
  Throws:
    `HibernateException` - An error from Hibernate
  See Also:
    `Type.hydrate(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### semiResolve

    public Object semiResolve(Object value,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException

  Description copied from interface: `Type`
  Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.

  Specified by:
    `semiResolve` in interface `Type`
  Overrides:
    `semiResolve` in class `AbstractType`
  Parameters:
    `value` - The unresolved, hydrated value
    `session` - THe originating session
    `owner` - The value owner
  Returns:
    The semi-resolved value
  Throws:
    `HibernateException` - An error from Hibernate

### nullSafeSet

    public void nullSafeSet(PreparedStatement st,
                            Object value,
                            int index,
                            SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Description copied from interface: `Type`
  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement. Implementors should handle possibility of null values. A multi-column type should bind parameters starting from `index`.

  Specified by:
    `nullSafeSet` in interface `Type`
  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `index` - starting parameter bind index
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### nullSafeSet

    public void nullSafeSet(PreparedStatement st,
                            Object value,
                            int index,
                            boolean[] settable,
                            SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Description copied from interface: `Type`
  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter. Implementors should handle the possibility of null values. A multi-column type should bind parameters starting from `index`.

  Specified by:
    `nullSafeSet` in interface `Type`
  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `index` - starting parameter bind index
    `settable` - an array indicating which columns to bind/ignore
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### getReturnedClass

    public Class getReturnedClass()

  Description copied from interface: `Type`
  The class returned by `Type.nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods. This is used to establish the class of an array of this type.

  Specified by:
    `getReturnedClass` in interface `Type`
  Returns:
    The java type class handled by this type.

### sqlTypes

    public int[] sqlTypes(Mapping mapping)
                   throws MappingException

  Description copied from interface: `Type`
  Return the JDBC types codes (per `Types`) for the columns mapped by this type.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `sqlTypes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The JDBC type codes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### dictatedSizes

    public Size[] dictatedSizes(Mapping mapping)
                         throws MappingException

  Description copied from interface: `Type`
  Return the column sizes dictated by this type. For example, the mapping for a `char`/`Character` would have a dictated length limit of 1; for a string-based `UUID` would have a size limit of 36; etc.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `dictatedSizes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The dictated sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### defaultSizes

    public Size[] defaultSizes(Mapping mapping)
                        throws MappingException

  Description copied from interface: `Type`
  Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `defaultSizes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The default sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### setToXMLNode

    public void setToXMLNode(org.dom4j.Node xml,
                             Object value,
                             SessionFactoryImplementor factory)

  Description copied from interface: `Type`
  A representation of the value to be embedded in an XML element.

  Specified by:
    `setToXMLNode` in interface `Type`
  Parameters:
    `xml` - The XML node to which to write the value
    `value` - The value to write
    `factory` - The session factory

### toLoggableString

    public String toLoggableString(Object value,
                                   SessionFactoryImplementor factory)
                            throws HibernateException

  Description copied from interface: `Type`
  Generate a representation of the value for logging purposes.

  Specified by:
    `toLoggableString` in interface `Type`
  Parameters:
    `value` - The value to be logged
    `factory` - The session factory
  Returns:
    The loggable representation
  Throws:
    `HibernateException` - An error from Hibernate

### fromXMLNode

    public Object fromXMLNode(org.dom4j.Node xml,
                              Mapping factory)
                       throws HibernateException

  Description copied from interface: `Type`
  Parse the XML representation of an instance.

  Specified by:
    `fromXMLNode` in interface `Type`
  Parameters:
    `xml` - The XML node from which to read the value
    `factory` - The session factory
  Returns:
    an instance of the `mapped class`
  Throws:
    `HibernateException` - An error from Hibernate

### assemble

    public Object assemble(Serializable cached,
                           SessionImplementor session,
                           Object owner)
                    throws HibernateException

  Description copied from interface: `Type`
  Reconstruct the object from its disassembled state. This method is the reciprocal of `Type.disassemble(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

  Specified by:
    `assemble` in interface `Type`
  Overrides:
    `assemble` in class `AbstractType`
  Parameters:
    `cached` - the disassembled state from the cache
    `session` - the originating session
    `owner` - the parent entity object
  Returns:
    the (re)assembled object
  Throws:
    `HibernateException` - An error from Hibernate

### disassemble

    public Serializable disassemble(Object value,
                                    SessionImplementor session,
                                    Object owner)
                             throws HibernateException

  Description copied from interface: `Type`
  Return a disassembled representation of the object. This is the value Hibernate will use in second level caching, so care should be taken to break values down to their simplest forms; for entities especially, this means breaking them down into their constituent parts.

  Specified by:
    `disassemble` in interface `Type`
  Overrides:
    `disassemble` in class `AbstractType`
  Parameters:
    `value` - the value to cache
    `session` - the originating session
    `owner` - optional parent entity object (needed for collections)
  Returns:
    the disassembled, deep cloned state
  Throws:
    `HibernateException` - An error from Hibernate

### isAnyType

    public boolean isAnyType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `AnyType`. Essentially a polymorphic version of `(type instanceof AnyType.class)`.

  An `AnyType` is additionally an `AssociationType`; so if this method returns true, `Type.isAssociationType()` should also return true.

  Specified by:
    `isAnyType` in interface `Type`
  Overrides:
    `isAnyType` in class `AbstractType`
  Returns:
    True if this type is also an `AnyType` implementor; false otherwise.

### replace

    public Object replace(Object original,
                          Object target,
                          SessionImplementor session,
                          Object owner,
                          Map copyCache)
                   throws HibernateException

  Description copied from interface: `Type`
  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Specified by:
    `replace` in interface `Type`
  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
    `session` - The originating session
    `owner` - The owner of the value
    `copyCache` - The cache of already copied/replaced values
  Returns:
    the value to be merged
  Throws:
    `HibernateException` - An error from Hibernate

### getCascadeStyle

    public CascadeStyle getCascadeStyle(int i)

  Description copied from interface: `CompositeType`
  Retrieve the cascade style of the indicated component property.

  Specified by:
    `getCascadeStyle` in interface `CompositeType`
  Parameters:
    `i` - The property index,
  Returns:
    The cascade style.

### getFetchMode

    public FetchMode getFetchMode(int i)

  Description copied from interface: `CompositeType`
  Retrieve the fetch mode of the indicated component property.

  Specified by:
    `getFetchMode` in interface `CompositeType`
  Parameters:
    `i` - The property index,
  Returns:
    The fetch mode

### getPropertyNames

    public String[] getPropertyNames()

  Description copied from interface: `CompositeType`
  Get the names of the component properties

  Specified by:
    `getPropertyNames` in interface `CompositeType`
  Returns:
    The component property names

### getPropertyValue

    public Object getPropertyValue(Object component,
                                   int i,
                                   SessionImplementor session)
                            throws HibernateException

  Description copied from interface: `CompositeType`
  Extract a particular component property value indicated by index.

  Specified by:
    `getPropertyValue` in interface `CompositeType`
  Parameters:
    `component` - The component instance
    `i` - The index of the property whose value is to be extracted
    `session` - The session from which the request originates.
  Returns:
    The extracted component property value
  Throws:
    `HibernateException` - Indicates a problem access the property value.

### getPropertyValues

    public Object[] getPropertyValues(Object component,
                                      SessionImplementor session)
                               throws HibernateException

  Description copied from interface: `CompositeType`
  Extract the values of the component properties from the given component instance

  Specified by:
    `getPropertyValues` in interface `CompositeType`
  Parameters:
    `component` - The component instance
    `session` - The session from which the request originates
  Returns:
    The property values
  Throws:
    `HibernateException` - Indicates a problem access the property values.

### getSubtypes

    public Type[] getSubtypes()

  Description copied from interface: `CompositeType`
  Get the types of the component properties

  Specified by:
    `getSubtypes` in interface `CompositeType`
  Returns:
    The component property types.

### setPropertyValues

    public void setPropertyValues(Object component,
                                  Object[] values,
                                  EntityMode entityMode)
                           throws HibernateException

  Description copied from interface: `CompositeType`
  Inject property values onto the given component instance

  An optional operation

  Specified by:
    `setPropertyValues` in interface `CompositeType`
  Parameters:
    `component` - The component instance
    `values` - The values to inject
    `entityMode` - The entity mode
  Throws:
    `HibernateException` - Indicates an issue performing the injection

### getPropertyValues

    public Object[] getPropertyValues(Object component,
                                      EntityMode entityMode)

  Description copied from interface: `CompositeType`
  Extract the values of the component properties from the given component instance without access to the session.

  An optional operation

  Specified by:
    `getPropertyValues` in interface `CompositeType`
  Parameters:
    `component` - The component instance
    `entityMode` - The entity mode
  Returns:
    The property values

### isComponentType

    public boolean isComponentType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `CompositeType`. Essentially a polymorphic version of `(type instanceof CompositeType.class)`. A component type may own collections or associations and hence must provide certain extra functionality.

  Specified by:
    `isComponentType` in interface `Type`
  Overrides:
    `isComponentType` in class `AbstractType`
  Returns:
    True if this type is also an `CompositeType` implementor; false otherwise.

### getForeignKeyDirection

    public ForeignKeyDirection getForeignKeyDirection()

  Description copied from interface: `AssociationType`
  Get the foreign key directionality of this association

  Specified by:
    `getForeignKeyDirection` in interface `AssociationType`

### isAssociationType

    public boolean isAssociationType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `AssociationType`. This does not necessarily imply that the type actually represents an association. Essentially a polymorphic version of `(type instanceof AssociationType.class)`

  Specified by:
    `isAssociationType` in interface `Type`
  Overrides:
    `isAssociationType` in class `AbstractType`
  Returns:
    True if this type is also an `AssociationType` implementor; false otherwise.

### useLHSPrimaryKey

    public boolean useLHSPrimaryKey()

  Description copied from interface: `AssociationType`
  Is the primary key of the owning entity table to be used in the join?

  Specified by:
    `useLHSPrimaryKey` in interface `AssociationType`

### getAssociatedJoinable

    public Joinable getAssociatedJoinable(SessionFactoryImplementor factory)

  Description copied from interface: `AssociationType`
  Get the "persister" for this association - a class or collection persister

  Specified by:
    `getAssociatedJoinable` in interface `AssociationType`

### isModified

    public boolean isModified(Object old,
                              Object current,
                              boolean[] checkable,
                              SessionImplementor session)
                       throws HibernateException

  Description copied from interface: `Type`
  Has the value been modified compared to the current database state? The difference between this and the `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values. This is really only an issue with association types. For most type implementations it is enough to simply delegate to `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` here/

  Specified by:
    `isModified` in interface `Type`
  Overrides:
    `isModified` in class `AbstractType`
  Parameters:
    `old` - the database state, in a "hydrated" form, with identifiers unresolved
    `current` - the current state of the object
    `checkable` - which columns are actually updatable
    `session` - The session from which the request originated.
  Returns:
    true if the field has been modified
  Throws:
    `HibernateException` - A problem occurred performing the checking

### getAssociatedEntityName

    public String getAssociatedEntityName(SessionFactoryImplementor factory)
                                   throws MappingException

  Description copied from interface: `AssociationType`
  Get the entity name of the associated entity

  Specified by:
    `getAssociatedEntityName` in interface `AssociationType`
  Throws:
    `MappingException`

### getPropertyNullability

    public boolean[] getPropertyNullability()

  Description copied from interface: `CompositeType`
  Retrieve the indicators regarding which component properties are nullable.

  An optional operation

  Specified by:
    `getPropertyNullability` in interface `CompositeType`
  Returns:
    nullability of component properties

### getOnCondition

    public String getOnCondition(String alias,
                                 SessionFactoryImplementor factory,
                                 Map enabledFilters)
                          throws MappingException

  Description copied from interface: `AssociationType`
  Get the "filtering" SQL fragment that is applied in the SQL on clause, in addition to the usual join condition

  Specified by:
    `getOnCondition` in interface `AssociationType`
  Throws:
    `MappingException`

### isReferenceToPrimaryKey

    public boolean isReferenceToPrimaryKey()

### getRHSUniqueKeyPropertyName

    public String getRHSUniqueKeyPropertyName()

  Description copied from interface: `AssociationType`
  The name of a unique property of the associated entity that provides the join key (null if the identifier of an entity, or key of a collection)

  Specified by:
    `getRHSUniqueKeyPropertyName` in interface `AssociationType`

### getLHSPropertyName

    public String getLHSPropertyName()

  Description copied from interface: `AssociationType`
  Get the name of a property in the owning entity that provides the join key (null if the identifier)

  Specified by:
    `getLHSPropertyName` in interface `AssociationType`

### isAlwaysDirtyChecked

    public boolean isAlwaysDirtyChecked()

  Description copied from interface: `AssociationType`
  Do we dirty check this association, even when there are no columns to be updated?

  Specified by:
    `isAlwaysDirtyChecked` in interface `AssociationType`

### isEmbeddedInXML

    public boolean isEmbeddedInXML()

  Specified by:
    `isEmbeddedInXML` in interface `AssociationType`

### toColumnNullness

    public boolean[] toColumnNullness(Object value,
                                      Mapping mapping)

  Description copied from interface: `Type`
  Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.

  Specified by:
    `toColumnNullness` in interface `Type`
  Parameters:
    `value` - an instance of the type
    `mapping` - The mapping abstraction
  Returns:
    array indicating column nullness for a value instance

### isDirty

    public boolean isDirty(Object old,
                           Object current,
                           boolean[] checkable,
                           SessionImplementor session)
                    throws HibernateException

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current value?

  Specified by:
    `isDirty` in interface `Type`
  Parameters:
    `old` - the old value
    `current` - the current value
    `checkable` - An array of booleans indicating which columns making up the value are actually checkable
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### isEmbedded

    public boolean isEmbedded()

  Description copied from interface: `CompositeType`
  Is this component embedded? "embedded" indicates that the component is "virtual", that its properties are "flattened" onto its owner

  Specified by:
    `isEmbedded` in interface `CompositeType`
  Returns:
    True if this component is embedded; false otherwise.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2012 Red Hat, Inc. All Rights Reserved.